<template>
  <div id="nav">
    <div id="nav-top">
      <div id="nav-top-row1">
        <Logo />
        <div id="nav-top-icons">
          <Icon icon="sidebar" size="32px" color="C-737278" />
          <Icon icon="plus" size="32px" color="C-737278" />
          <Icon icon="search" size="32px" color="C-737278" />
          <img class="user" src='/user.png' alt="GitLab">
        </div>
      </div>
      <Switchersuper :user="userComp" v-if="switchertype === 'super' "/>
      <div id="nav-top-row2">
        <button class="nav-top-button">
          <Icon icon="issues" size="32px" color="C-737278" />
          {{ userComp.issues }}
        </button>
        <button class="nav-top-button">
          <Icon icon="merge-request" size="32px" color="C-737278" />
          {{ userComp.mergerequests }}
        </button>
        <button class="nav-top-button">
          <Icon icon="todo-done" size="32px" color="C-737278" />
          {{ userComp.todo }}
        </button>
      </div>
    </div>
    <Switcher :user="userComp" v-if="switchertype === 'default'"/>
    <Switcherslide :user="userComp" v-if="switchertype === 'slide' "/>
    <Switchermodal :user="userComp" v-if="switchertype === 'modal' "/>
    <div id="navlist" :class="{ openSwitcher: isSwitcherOpen & switchertype !== 'super' }">
      <NavItem v-for="item in navlist"
        :label=item.title
        :icon=item.icon
        :navurl=item.url
        :isexpandable=item.expandable
        :user=userComp
      />
    </div>
  </div>
</template>

<script setup>
import { useMainStore } from '~~/stores/main';
import { storeToRefs } from 'pinia';
import { computed, ref } from 'vue'

const main = useMainStore();
const { isSwitcherOpen, section } = storeToRefs(main);


const { data: user } = await useAsyncData('user', () => queryContent('/comp/user').findOne())
const { data: pagelist } = await useAsyncData('nav', () => queryContent('/comp/nav').findOne())

const route = useRoute();

const userComp = computed({
  get () {
    let usermd = {};
    let content = {
      error: false,
      issues: 0,
      mergerequests: 0,
      todo: 0,
      switcher: {
        projects: {
          item: {
            label: "Error",
            icon: "",
            url: "mywork-projects"
          }
        },
        groups: {
          item: {
            label: "Error",
            icon: "",
            url: "mywork-projects"
          }
        }
      }
    };
    switch (section.value.org) {
      case "a":
        usermd = user.value.a
        break;
      case "b":
        usermd = user.value.b
        break;
      case "c":
        usermd = user.value.c
        break;
      default:
        usermd = user.value.a
        break;
    }
    try {
      content.issues = usermd.issues;
      content.mergerequests = usermd.mergerequests;
      content.todo = usermd.todo;
      content.switcher.projects = usermd.switcher.projects;
      content.switcher.groups = usermd.switcher.groups;
    } catch (error) {
      content.error = true;
    }
    return content;
  }
})

const navlist = computed({
  get () {
    let content = {
      error: {
        title: 'Error',
        icon: 'error',
        url: 'error'
      }
    }
    try {
      content = pagelist.value[section.value.id].pages
    } catch (error) {
      console.log("Main nav error");
    }
    return content;
  }
})

const switchertype = computed(() => {
    let sw = route.query.switcher
    try {
      sw.length
    } catch (error) {
      sw = 'default'
    }
    return sw
});

</script>

<style>
#nav {
  position: fixed;
  height: 100%;
  top: 0;
  bottom: 0;
  left: 0;
  background-color: #FBFAFD;
  border-right: 1px solid rgba(31, 30, 36, 0.08);
  transform: translate3d(0, 0, 0);
  width: 256px;
  z-index: 100;
  color: #333238;
}

#nav-top {
  background-color: rgba(31, 30, 36, 0.04);
  border-bottom: 1px solid #ECECEF;
  padding: 2px 4px 4px 4px;
}

#nav-top-row1 {
  display: flex;
  justify-content: space-between;
  align-items: center;
}

#nav-top-icons {
  display: flex;
  justify-content: right;
  align-items: center;
}

.user {
  height: 28px;
  width: 28px;
  padding: 2px 2px 2px 2px;
}

#nav-top-row2 {
  display: flex;
  justify-content: center;
  align-items: center;
  gap: 4px;
  padding: 4px 4px 0 4px;
}

.nav-top-button {
  display: flex;
  flex-grow: 1;
  align-items: center;
  justify-content: center;
  height: 32px;
  background-color: #FBFAFD;
  border-radius: 4px;
  border: none;
  box-shadow: inset 0 0 0 1px rgba(31, 30, 36, 0.08);
  color: #333238;
  font-size: 12px;
}

.nav-top-button:hover {
  background-color: #ECECEF;
}

#nav-top-button-center {
  margin: 0 4px 0 4px;
}

#navlist {
  padding: 8px 4px 4px 4px;
}

.openSwitcher {
  opacity: 0%;
  visibility: hidden;
  animation: slide-out .2s ease-in;
  background-color: #FBFAFD;
  border-right: 1px solid rgba(31, 30, 36, 0.08);
  width: 256px;
  height: 1600px;
  z-index: 200;
}

@keyframes slide-out {
  0% {
    position: absolute;
    top: 140px;
    opacity: 100%;
    visibility: visible;
  }

  50% {
    opacity: 100%;
  }

  100% {
    position: absolute;
    top: 800px;
    opacity: 0%;
    visibility: hidden;
  }
}
</style>